;λ:RESET 
; ѭ :MAIN_LOOP

$EP(ERROR.TXT)
$INCLUDE(New51Pro.H51)

;**********************************************
	ORG	0000H
BEGIN:	LJMP	RESET
	ORG	0023H		;SERIAL	INTERRUPT
UARTI:	LJMP	S_INTR
	ORG	0030H
	DB	"My Small Progam!"

;************************************************
;****** ϵ縴λ ******************************
;************************************************
	ORG	0040H
RESET:	MOV	SP,#50H

CLR_RAM:CLR 	A
	MOV 	R0,#0FFH
	MOV 	@R0,A
        DJNZ 	R0,$-1
	LCALL	INI_FSR
	
INI_SYS:CLR	IO_SW0		;״̬40 Pins
	MOV	RX_CNT,#0
	MOV	TX_CNT,#0
	MOV	RX_PIN,#RXD_HAD
	MOV	TX_PIN,#TXD_HAD
	DEL_mS	200		;=200mS
	
START:	SETB	TR1
	SETB	EA

HELLO:	MOV	DPTR,#MSG_HELLO
	LCALL	SEND_MSG
	

;*************************************************
;*******  ******************************
;*************************************************
MAIN_LOOP:			;
	JB	OK_RXD,ANS_COMMAND
	;-----------------------
	;JNB	RI,MAIN_LOOP
	;LCALL	S_INTR
	;-----------------------
	SJMP	MAIN_LOOP

;-------------------------------------------------
ANS_COMMAND:
	CLR	OK_RXD		;
	MOV	DPTR,#CMD_TAB	;
	MOV	A,RX_CODE
	ANL	A,#07H
	RL	A		;
	JMP	@A+DPTR
CMD_TAB:
	SJMP	CMD_REST	;0
	SJMP	CMD_BANK	;1
	SJMP	CMD_READ	;2
	SJMP	CMD_PROG	;3
	SJMP	CMD_ERAS	;4
	SJMP	CMD_LOCK	;5
	SJMP	CMD_SETT	;6
	SJMP	CMD_SING	;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CMD_REST:			;λ
	SJMP	RESET
CMD_BANK:			;
	LCALL	CHECK_BANK
	SJMP	CMD_END
CMD_READ:			;
	LCALL	READ_ROM
	SJMP	CMD_END
CMD_PROG:			;
	LCALL	PROG_ROM
	SJMP	CMD_END
CMD_ERAS:			;
	LCALL	ERASE_ROM
	SJMP	CMD_END
CMD_LOCK:			;
	LCALL	LOCK_CHIP
	SJMP	CMD_END
CMD_SETT:			;
	LCALL	SET_TYPE
	SJMP	CMD_END
CMD_SING:			;
	LCALL	TEST_SING

CMD_END:SJMP	MAIN_LOOP
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;***********************************************
;******  ******************************
;***********************************************

;====== ROM  ================================
;һıӦ
CHECK_BANK:
	MOV	R0,#RXD_BUF		;
	MOV	R1,#(RXD_BUF+1)		;
	MOV	SADD_H,RX_PAR1		;ʼַ
	MOV	SADD_L,RX_PAR2		;
	MOV	EADD_H,@R0		;ַܽ
	MOV	EADD_L,@R1		;
BAK_INI:MOV	A,TYPE
	;չ
bank_2:	CJNE	A,#W_E5xx,bank_1
	LCALL	BANK_E5xx		;IS W78E5x
	SJMP	BANK_OK
bank_1:	CJNE	A,#A_C5xx,bank_0		;
	LCALL	BANK_C5xx		;IS AT89C5x
	SJMP	BANK_OK
bank_0:	CJNE	A,#A_x051,BANK_END	;
	LCALL	BANK_x051		;IS AT89Cx051

BANK_OK:JC	NO_BANK
IS_BANK:MOV	DPTR,#MSG_BANK
	SJMP	BANK_OV
NO_BANK:MOV	DPTR,#MSG_UNBAK	
BANK_OV:LCALL	SEND_MSG
	SETB	REN
BANK_END:
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;======  ROM  ===============================
;һıӦ
ERASE_ROM:
	MOV	A,TYPE
	;չ
eras_1:	CJNE	A,#W_E5xx,eras_2		;
	LCALL	ERS_E5xx                 ;IS W78E5x    
	SJMP	ERAS_OK
eras_2:	CJNE	A,#A_C5xx,eras_3         ;              
	LCALL	ERS_C5xx                 ;IS AT89C5x    
	SJMP	ERAS_OK
eras_3:	CJNE	A,#A_x051,ERAS_END      	; 
	LCALL	ERS_x051                 ;IS AT89Cx051  

ERAS_OK:MOV	DPTR,#MSG_ERASE
	LCALL	SEND_MSG
	SETB	REN
ERAS_END:
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== 趨оƬ =================================
;һıӦ
SET_TYPE:
	MOV	TYPE,RX_PAR1
	MOV	A,RX_PAR2
	ANL	A,#0FH
	MOV	VPP,A
	MOV	A,RX_PAR2
	SWAP	A
	ANL	A,#0FH
	MOV	VEP,A
TYP_INI:MOV	A,TYPE
	;չ
SET_E5x:CJNE	A,#W_E5xx,SET_C5x
	CLR	IO_SW0		;Select 40Pins
	SJMP	TYPE_OK
SET_C5x:CJNE	A,#A_C5xx,SET_x05
	CLR	IO_SW0		;Select 40Pins
	SJMP	TYPE_OK
SET_x05:CJNE	A,#A_x051,TYPE_OK
	SETB	IO_SW0		

TYPE_OK:VPP_05V
	MOV	DPTR,#MSG_TYPE
	LCALL	SEND_MSG
	SETB	REN
TYPE_END:
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== оƬ ==========================
;һıӦ
TEST_SING: 			;
	MOV	A,TYPE
	;չ
S_E5x:	CJNE	A,#W_E5xx,S_C5x
	LCALL	GET_E5x		;ȱ
	SJMP	SING_OK
S_C5x:	CJNE	A,#A_C5xx,S_x051
	LCALL	GET_C5xx
	SJMP	SING_OK
S_x051:	CJNE	A,#A_x051,TEST_END
	LCALL	GET_x051

SING_OK:SETB	REN		;Ž
TEST_END:
	RET	
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;======  ROM  ===========================
;FUN:	ÿεöһ֡(16ֽ)ROM
;SADD:	ÿ֡ʼַ
;CADD:	ÿַ֡
;EADD:	ܵĽַ
READ_ROM:
	MOV	R0,#RXD_BUF		;=4: Ԥ
	MOV	R1,#(RXD_BUF+1)		;=4: Ԥ
	MOV	A,RX_LENG
RED_PER:MOV	SADD_H,RX_PAR1		;ʼַ
	MOV	SADD_L,RX_PAR2		;
RED_ST:	CJNE	A,#4,RED_INI		;<4: 
	MOV	EADD_H,@R0		;ַܽ
	MOV	EADD_L,@R1		;
	CLR	IN_RED			;׼״̬
	MOV	A,#R_CODE		;
	ANSWER	0			;Ӧ
	SJMP	RED_END

RED_INI:MOV	A,TYPE
	;չ
read_2:	CJNE	A,#W_E5xx,read_1
	LCALL	READ_E5xx		;IS W78E5x
	SJMP	RED_OK
read_1:	CJNE	A,#A_C5xx,read_0		;
	LCALL	READ_C5xx		;IS AT89C5x
	SJMP	RED_OK
read_0:	CJNE	A,#A_x051,RED_END	;
	LCALL	READ_x051		;IS AT89Cx051

RED_OK:	MOV	TX_PAR1,SADD_H		;ÿ16ֽϴ
	MOV	TX_PAR2,SADD_L
	MOV	A,#R_CODE
CK_ROV:	LCALL	CHK_OVE			;
	JNC	RED_NXT			;
RED_OVE:CLR	IN_RED			;
	SETB	ACC.4		;ĩ֡־
RED_NXT:
	ANSWER	18		;Ӧ: ϴ!
RED_END:
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== д ROM  ===========================
;FUN:	ÿεдһ֡(16ֽ)ROM
;SADD:	ÿ֡ʼַ
;CADD:	ÿַ֡
;EADD:	ܵĽַ
PROG_ROM:
	MOV	R0,#RXD_BUF		;=4: дԤ
	MOV	R1,#(RXD_BUF+1)		;=4: дԤ
PRG_PER:MOV	SADD_H,RX_PAR1		;
	MOV	SADD_L,RX_PAR2
PRG_ST:	MOV	A,RX_LENG
	CJNE	A,#4,PRG_INI		;>4: д
	MOV	EADD_H,@R0		;ַܽ
	MOV	EADD_L,@R1		;
	CLR	IN_PRG			;׼״̬
	MOV	A,#W_CODE
	SJMP	PRG_NXT
	
PRG_INI:MOV	A,TYPE
	;չ
prog_2:	CJNE	A,#W_E5xx,prog_1		;              
	LCALL	PROG_E5X                ;IS W78E5x    
	SJMP	PRG_OK
prog_1:	CJNE	A,#A_C5xx,prog_0         ;              
	LCALL	PROG_C5X                ;IS AT89C5x    
	SJMP	PRG_OK
prog_0:	CJNE	A,#A_x051,PRG_END		;              
	LCALL	PROG_051                ;IS AT89Cx051  

PRG_OK:	MOV	A,#W_CODE
CK_POV:	LCALL	CHK_OVE
	JNC	PRG_NXT			;?
PRG_OVE:CLR	IN_PRG
	LCALL	Read_ini		;̽
	MOV	A,#W_CODE
	SETB	ACC.4		;ĩ֡
PRG_NXT:
	ANSWER	0		;ؽ
PRG_END:
	RET                                            
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;--------------------------------------------------
Read_ini:
	VPP_05V
	MOV	A,TYPE
RDI_2:	CJNE	A,#W_E5xx,RDI_1
	LCALL	Read_E5x_ini
	SJMP	RDI_END
RDI_1:	CJNE	A,#A_C5xx,RDI_0
	LCALL	Read_C5x_ini
	SJMP	RDI_END
RDI_0:	CJNE	A,#A_x051,RDI_END
	LCALL	Read_x051_ini
	;SJMP	RDI_END
RDI_END:RET


;======  оƬ  =============================
;һıӦ
LOCK_CHIP:
	MOV	A,TYPE
	;չ
lock_2:	CJNE	A,#W_E5xx,lock_1        ;            
	LCALL	LOCK_E5xx                 ;IS W78E5x   
	SJMP	LOCK_OK                             
lock_1:	CJNE	A,#A_C5xx,lock_0         ;            
	LCALL	LOCK_C5xx                ;IS AT89C5x  
	SJMP	LOCK_OK                             
lock_0:	CJNE	A,#A_x051,LOCK_END     	;            
	LCALL	LOCK_x051                 ;IS AT89Cx051

LOCK_OK:MOV	DPTR,#MSG_LOCK
	LCALL	SEND_MSG
	SETB	REN
LOCK_END:	
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;*********************************************
;******  AT89Cx051 Ĺӳ ************
;*********************************************

;======	AT89Cx051 ӳ ==================
;һԶ꣬ɽַ EADD 
READ_x051:
	JB	IN_RED,R05_INI
Rx05_PRE:
	VPP_00V
	VPP_05V
	LCALL	Read_x051_ini	;IO init
	SETB	IN_RED
	;ʼѭ
R05_INI:MOV	DPH,SADD_H	;ܵʼַ
	MOV	DPL,SADD_L
	MOV	R0,#TXD_BUF
	MOV	R2,#10H
R05_LOP:MOV	P0,#0FFH	;֡ѭ
	READ_x051_DATA
	MOV	@R0,A		;Move Data
	INC	R0		;
	MOV	CADD_H,DPH	;ĩַ
	MOV	CADD_L,DPL	;
	INC	DPTR		;
	INC_x051_ADDR		;ַһ
	DJNZ	R2,R05_LOP	;֡ѭ

R05_END:RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== AT89Cx051 дӳ ================
PROG_051:
	JB	IN_PRG,P05_INI
	LCALL	P05_PRE
P05_INI:MOV	DPH,SADD_H
	MOV	DPL,SADD_L
	MOV	R0,#RXD_BUF	;ָ
	MOV	R2,RX_LENG	;
	DEC_n	R2,2
P05_LOP:MOV	A,@R0		;Get Data
	INC	R0		;Move Point
	LCALL	X051_DATA	;Reversal
	MOV	P0,A		;Out Data
	SET_x05_PROG
	INC_x051_ADDR
	MOV	CADD_H,DPH
	MOV	CADD_L,DPL
	INC	DPTR		;ڲַ
	DJNZ	R2,P05_LOP

P05_END:SETB	IN_PRG
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;---------------------------------
P05_PRE:VPP_00V
	VPP_05V
	LCALL	Prog_x051_ini
	SETB	IN_PRG
	SEL_VPP	VPP
	RET



;====== AT89CX051 ӳ ================
ERS_x051:
	VPP_05V	;-
	VPP_12V	;/			;Vpp=12V
	LCALL	Eras_x051_ini
	CLR	IO_prg		;
	DEL_mS	20		;>10mS
	SETB	IO_prg		;
	VPP_05V
	LCALL	Read_x051_ini
E05_END:RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;======	AT89Cx051 ȡӳ ==================
GET_x051:
	VPP_00V
	VPP_05V
	LCALL	Sing_x051_ini
x051_CORP:
	MOV	P0,#0FFH
	READ_x051_DATA
	CJNE	A,#1EH,NO_x0AT
IS_x0AT:MOV	DPTR,#MSG_ISAT
	SJMP	AS_x0AT
NO_x0AT:MOV	DPTR,#MSG_NOAT
AS_x0AT:LCALL	SEND_MSG

x051_SIZE:
	INC_x051_ADDR
	MOV	P0,#0FFH
	READ_x051_DATA
	ANL	A,#0F0H
	LCALL	SEND_BYTE
	MOV	A,#51H
	LCALL	SEND_BYTE

GET_x051_END:
	VPP_05V
	LCALL	Read_x051_ini
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;====== AT89Cx051 ܹӳ ============
LOCK_x051:
	MOV	A,RX_PAR1
LK_x05_Bit0:
	JB	ACC.0,LK_x051_B0
	LJMP	LK_x05_Bit1
LK_x051_B0:
	VPP_05V
	LCALL	LK0_x051_ini
	SEL_VPP	VPP
	SET_x05_PROG
LK_x05_Bit1:
	JB	ACC.1,LK_x051_B1
	LJMP	LK05_END
LK_x051_B1:
	VPP_05V
	LCALL	LK1_x051_ini
	SEL_VPP	VPP
	SET_x05_PROG
LK05_END:
	VPP_05V
	LCALL	Read_x051_ini
	RET

;======	AT89Cx051 ӳ ==================
;һԶ꣬ɽַ EADD 
BANK_x051:
	VPP_00V
	VPP_05V
	LCALL	Read_x051_ini	;IO init
	MOV	DPH,SADD_H	;
	MOV	DPL,SADD_L
B05_LOP:MOV	P0,#0FFH	;ʼѭ
	READ_x051_DATA
	CPL	A
B05_CHK:JNZ	B05_END		;ǿգ
	MOV	CADD_H,DPH	;
	MOV	CADD_L,DPL	;
	LCALL	CHK_OVE
	JC	B05_END		;
B05_NXT:INC	DPTR		;Address Increment
	INC_x051_ADDR		;ַһ
	SJMP	B05_LOP

B05_END:CPL	C
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;====== IO ʼӳ =======================
;--------------------------------------------
Read_x051_ini:
	SETB	IO_bsy		;set free
	SETB	IO_prg		;set free
	CLR	IO_p33		;\
	SETB	IO_p35		;-Read and Writ Enabled
	SETB	IO_p37		;/
	SETB	IO_p34		;Read Line prep.
	CLR	IO_xt1
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;--------------------------------------------
Sing_x051_ini:
	SETB	IO_bsy
	SETB	IO_prg		;READ SIGN
	CLR	IO_p33
	SETB	IO_p34		;Read Line prep.
	CLR	IO_p35
	CLR	IO_p37
	CLR	IO_xt1
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;--------------------------------------------
Prog_x051_ini:	
	SETB	IO_bsy		;set free
	CLR	IO_p33		;\
	SETB	IO_p34		;-Writ state
	SETB	IO_p35		;-Writ state
	SETB	IO_p37		;/

	SETB	IO_prg		;-Writ line prep.
	CLR	IO_xt1		;/
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;--------------------------------------------
Eras_x051_ini:	
	SETB	IO_bsy		;\
	SETB	IO_xt1		;-set free
	SETB	IO_prg		;/
	SETB	IO_p33
	CLR	IO_p34	
	CLR	IO_p35
	CLR	IO_p37
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;--------------------------------------------
LK0_x051_ini:
	SETB	IO_bsy
	SETB	IO_xt1
	SETB	IO_p33
	SETB	IO_p34
	SETB	IO_p35
	SETB	IO_p37
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;--------------------------------------------
LK1_x051_ini:
	SETB	IO_bsy
	SETB	IO_xt1
	SETB	IO_p33
	SETB	IO_p34
	CLR	IO_p35
	CLR	IO_p37
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;*********************************************
;******  AT89C5x Ĺӳ **************
;*********************************************

;======	AT89C5X ӳ ====================
;һԶ꣬ RX_PAR2 
READ_C5xx:
	JB	IN_RED,RC5_INI
RC5_PRE:VPP_05V
	LCALL	Read_C5x_ini	;
	SETB	IN_RED
	;ʼѭ
RC5_INI:MOV	DPH,SADD_H
	MOV	DPL,SADD_L
	MOV	R0,#TXD_BUF
	MOV	R2,#10H
RC5_LOP:MOV	P0,#0FFH	;֡ѭ
	READ_C5xx_DATA
	MOV	@R0,A		;Move Data
	INC	R0		;Move Point
	MOV	CADD_H,DPH
	MOV	CADD_L,DPL
	INC	DPTR		;Address Increment
	DJNZ	R2,RC5_LOP	;֡ѭ

RC5_END:RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
	
;======	AT89C5X дӳ ==================
PROG_C5X:
	JB	IN_PRG,PC5_INI
	LCALL	PC5_PRE
PC5_INI:MOV	DPH,SADD_H
	MOV	DPL,SADD_L
	MOV	R0,#RXD_BUF	;ָ
	MOV	R2,RX_LENG	;
	DEC_n	R2,2
PC5_LOP:MOV	A,@R0		;Get Data
	MOV	P0,A		;Out Data
	INC	R0		;
	LCALL	AT_ADDR		;Out Address
	MOV	CADD_H,DPH
	MOV	CADD_L,DPL
	INC	DPTR		;
	SET_C5x_PROG
	DJNZ	R2,PC5_LOP 	;Next Loop

PC5_END:SETB	IN_PRG
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;----------------------------------------------
PC5_PRE:VPP_05V
	LCALL	Prog_C5x_ini
	SETB	IN_PRG
	SEL_VPP	VPP
	RET


;====== AT89C5X ӳ ================
ERS_C5xx:
	VPP_12V 		;VPP=12.5V
	LCALL	Eras_C5x_ini
	CLR	AT_PRG		;
	DEL_mS	20		;>10mS
	SETB	AT_PRG		;
	VPP_05V
	LCALL	Read_C5x_ini
E5X_END:RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== AT89C5X ȡӳ ================
GET_C5xx:
	PUSH	DPL
	PUSH	DPH
GC5_REP:VPP_05V  		;VPP=5V
	CLR	IO_W_A		;Is ATMEL
	LCALL	Sing_C5x_ini
C5xx_CORP:	
	MOV 	P0,#0FFH
	MOV	DPTR,#0030H	;CORP.
	READ_C5xx_DATA
	CJNE	A,#1EH,NO_ATC5
IS_ATC5:MOV	DPTR,#MSG_ISAT
	SJMP	ANS_COR
NO_ATC5:MOV	DPTR,#MSG_NOAT
ANS_COR:LCALL	SEND_MSG

C5xx_SIZE:
	MOV 	P0,#0FFH
	MOV	DPTR,#0031H	;SIZE
	READ_C5xx_DATA
	LCALL	SEND_BYTE	
C5xx_V_PP:	
	MOV	DPTR,#MSG_VPP
	LCALL	SEND_MSG
	MOV 	P0,#0FFH
	MOV 	DPTR,#0032H	;VPP
	READ_C5xx_DATA
	CJNE	A,#05H,IS_C12V
	SJMP	C5xx_Vp
IS_C12V:MOV	A,#12H	
C5xx_Vp:LCALL	SEND_BYTE
	LCALL	Read_C5x_ini

GET_C5x_END:
	POP	DPH
	POP	DPL
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;====== AT89C5x ܹӳ ===================
LOCK_C5xx:
	MOV	A,RX_PAR1		;ܿ
L5x_B0:	JB	ACC.0,LK_C5xx_B0
	LJMP	L5x_B1
LK_C5xx_B0:
	VPP_05V
	LCALL	LK0_C5x_ini
	SEL_VPP	VPP
	SET_C5x_PROG
	
L5x_B1:	JB	ACC.1,LK_C5xx_B1
	LJMP	L5x_B2
LK_C5xx_B1:
	VPP_05V
	LCALL	LK1_C5x_ini
	SEL_VPP	VPP
	SET_C5x_PROG
	
L5x_B2:	JB	ACC.2,LK_C5xx_B2
	LJMP	L5x_END
LK_C5xx_B2:
	VPP_05V
	LCALL	LK2_C5x_ini
	SEL_VPP	VPP
	SET_C5x_PROG
	
L5x_END:VPP_05V
	LCALL	Read_C5x_ini
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;======	AT89C5x ӳ =====================
;һԲ꣬˳ EADD 
BANK_C5xx:
	VPP_05V			;?
	LCALL	Read_C5x_ini
	MOV	DPH,SADD_H
	MOV	DPL,SADD_L
BC5_LOP:MOV	P0,#0FFH	;ʼѭ
	READ_C5xx_DATA
	CPL	A
BC5_CHK:JNZ	BC5_END		;ǿգ
	MOV	CADD_H,DPH	;
	MOV	CADD_L,DPL	;
	LCALL	CHK_OVE
	JC	BC5_END		;
BC5_NXT:INC	DPTR		;Address Increment
	SJMP	BC5_LOP

BC5_END:CPL	C
	RET		;C=0:ȫգC=1:ǿ
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== AT89C5x IO ʼӳ ===============
Read_C5x_ini:	
	CLR	IO_W_A		;Is ATMEL
	SETB	AT_BSY		;set free
	SETB	AT_PRG		;
	CLR	AT_P26		;\
	SETB	AT_P36		;-Read or writ Enabled
	SETB	AT_P37		;/
	SETB	AT_P27		;Read line prep.
	DEL_mS	50
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------------
Prog_C5x_ini:	
	CLR	IO_W_A		;Is ATMEL
	SETB	AT_BSY		;
	CLR	AT_P26		;...
	SETB	AT_P27		;in WRIT Mode!
	SETB	AT_P36		;...
	SETB	AT_P37		;...
	SETB	AT_PRG		;prep.
	DEL_mS	50
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------------
Eras_C5x_ini:
	CLR	IO_W_A		;Is ATMEL
	SETB	AT_BSY		;set free
	SETB	AT_PRG		;
	SETB	AT_P26
	CLR	AT_P27
	CLR	AT_P36
	CLR	AT_P37
	DEL_mS	50
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------------
Sing_C5x_ini:
	SETB	AT_BSY		;
	SETB 	AT_PRG		;\
	CLR	AT_P26		; \
	CLR	AT_P27		;--READ SIGNATURE
	CLR 	AT_P36		; /
	CLR 	AT_P37		;/
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------------
LK0_C5x_ini:
	SETB	AT_P26	
	SETB	AT_P27	
	SETB	AT_P36	
	SETB	AT_P36	
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------------
LK1_C5x_ini:
	SETB	AT_P26	
	SETB	AT_P27	
	CLR	AT_P36	
	CLR	AT_P36	
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------------
LK2_C5x_ini:
	SETB	AT_P26	
	CLR	AT_P27	
	SETB	AT_P36	
	CLR	AT_P36	
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
	

;*********************************************
;******  W7xE5x Ĺӳ ***************
;*********************************************

;======	W78E5x ӳ =====================
;һԶ꣬ RX_PAR2 
READ_E5xx:
	JB	IN_RED,RE5_INI	
RE5_PRE:VPP_05V			;?
	LCALL	Read_E5x_ini
	SETB	IN_RED
	;ʼѭ
RE5_INI:MOV	DPH,SADD_H
	MOV	DPL,SADD_L
	MOV	R2,#10H
	MOV	R0,#TXD_BUF
RE5_LOP:MOV	P0,#0FFH	;֡ѭ
	READ_E5xx_DATA
	MOV	@R0,A		;Move Data
	INC	R0		;Move Point
	MOV	CADD_H,DPH	;
	MOV	CADD_L,DPL	;
	INC	DPTR		;Address Increment
	WAIT	10
	DJNZ	R2,RE5_LOP	;֡ѭ
	
RE5_END:RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== W78E5X дӳ =================
PROG_E5X:
	JB	IN_PRG,PE5_INI
	LCALL	PE5_PRE
PE5_INI:MOV	DPH,SADD_H
	MOV	DPL,SADD_L
	MOV	R0,#RXD_BUF
	MOV	R2,RX_LENG	;
	DEC_n	R2,2
PE5_LOP:MOV	P1,DPL		;Out L_Address
	MOV	P2,DPH		;Out H_Address
	MOV	A,@R0		;Get Data
	MOV	P0,A		;Out Data
	INC	R0		;Move Point
	MOV	CADD_H,DPH
	MOV	CADD_L,DPL
	INC	DPTR		;Address Increment
	SET_E5x_PROG
	DJNZ	R2,PE5_LOP 	;

PE5_END:SETB	IN_PRG
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;----------------------------------
PE5_PRE:VPP_05V
	LCALL	Prog_E5x_ini
	SETB	IN_PRG
	SEL_VPP	VPP
	RET


;====== W7xE5x ӳ =======================
ERS_E5xx:
	VPP_05V
	LCALL	Eras_E5x_ini
	SEL_VPP	VEP
	CLR	WB_P36		;\
	DEL_mS	15		;-ALL ERASE
	SETB	WB_P36		;/
	VPP_05V
	LCALL	Read_E5x_ini
EW5_END:RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;======  ===========================
GET_E5x:VPP_05V
	MOV	DPTR,#MSG_UNTYP
	LCALL	SEND_MSG
	RET

;====== W78E5x ܹӳ ========
LOCK_E5xx:
	VPP_05V
	LCALL	Prog_E5x_ini	
	SEL_VPP	VPP
	
LE5x_B:	MOV	A,RX_PAR1
	ORL	A,#0F0H
	MOV	P0,A
	MOV	P1,#0FFH
	MOV	P2,#0FFH
	WAIT	100
	SET_E5x_PROG
	VPP_05V
	LCALL	Read_E5x_ini	
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;======	W78E5x ӳ =====================
;һԲ꣬˳ EADD 
BANK_E5xx:
	VPP_05V			;?
	LCALL	Read_E5x_ini
	MOV	DPH,SADD_H
	MOV	DPL,SADD_L
BE5_LOP:MOV	P0,#0FFH	;ʼѭ
	READ_E5xx_DATA
	CPL	A
BE5_CHK:JNZ	BE5_END		;ǿգ
	MOV	CADD_H,DPH	;
	MOV	CADD_L,DPL	;
	LCALL	CHK_OVE
	JC	BE5_END		;
BE5_NXT:INC	DPTR		;Address Increment
	SJMP	BE5_LOP

BE5_END:CPL	C
	RET		;C=0:ȫգC=1:ǿ
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== W7xE5x IO ʼӳ ==================
Read_E5x_ini:
	SETB	IO_W_A		;Is WINBOND
	CLR	WB_P30		;...
	CLR	WB_P31		;READ!
	CLR	WB_P33		;READ!
	CLR	WB_PRG		;==L!
	CLR	WB_P36		;...
	SETB	WB_P37		;Read line prep.
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------
Prog_E5x_ini:
	SETB	IO_W_A		;Is WINBOND
	CLR	WB_P30
	CLR	WB_P31
	CLR	WB_P33
	SETB	WB_P36
	SETB	WB_P37
	RET
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
;-----------------------------------------------
Eras_E5x_ini:
	SETB	IO_W_A		;Is WINBOND
	SETB	WB_P30
	CLR	WB_P31
	CLR	WB_P33
	CLR	WB_PRG
	SETB	WB_P36
	SETB	WB_P37
	RET	
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;-----------------------------------------------
;====== ӳ ===============

	
;------ дж -----------------
;IN:	CADD,EADD
;OUT:	C=0: no over;	C=1: is over
CHK_OVE:PUSH	ACC
	CLR	C
	MOV	A,CADD_L
	SUBB	A,EADD_L
	MOV	A,CADD_H
	SUBB	A,EADD_H
OVE_END:CPL	C
	POP	ACC
	RET	
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;============================================

;======= һֽڵĴ ===================
SEND_BYTE:
	CLR	ES
	PUSH	ACC
	MOV 	B,A
	SWAP	A
	ANL 	A,#0FH
	LCALL 	SEND_HEX
	MOV 	A,B
	ANL 	A,#0FH
	LCALL 	SEND_HEX
	POP	ACC
	SETB	ES
SB_END:	RET
;=======================================
SEND_HEX:
	PUSH 	DPH
	PUSH 	DPL
	MOV 	DPTR,#ASC
	MOVC 	A,@A+DPTR
	MOV 	SBUF,A
	JNB 	TI,$
	CLR 	TI
	POP 	DPL
	POP 	DPH
SH_END:	RET
ASC:	DB "0123456789ABCDEF"


;====== ַӳ ====================================
;IN:	DPTR
;OUT:	SBUF
;USE:	ACC,DPTR
SEND_MSG:
	CLR	ES
	CLR	A
	MOVC	A,@A+DPTR
	CJNE	A,#'$',SEND_0
	SJMP	MSG_END
SEND_0:	MOVE	TB8,P
	MOV	SBUF,A
	JNB	TI,$		;
	CLR	TI 		;
	INC	DPTR
	SJMP	SEND_MSG
MSG_END:SETB	ES
	RET
	;;;;;;;;;;;;;;;;;;
	LJMP	RESET
	NOP
	NOP


;****** 㷨ӳ ********************************

;====== ASCII TO HEX =============================
ASC2HEX:CLR	C
	PUSH	DPH
	PUSH	DPL
	SUBB	A,#30H 
	MOV	DPTR,#ASC2
	MOVC	A,@A+DPTR
	POP	DPL
	POP	DPH
	RET
ASC2:	DB	0,1,2,3,4,5,6,7,8,9,0AH,0BH,0CH,0DH,0EH,0FH
	DB	0,0AH,0BH,0CH,0DH,0EH,0FH

;======  AT89C5X ַ ========================
AT_ADDR:PUSH	ACC
	PUSH	PSW
AT_ADDL:MOV	P1,DPL
AT_ADDM:MOV	A,DPH
	MOVE	P2.0,ACC.0
	MOVE	P2.1,ACC.1
	MOVE	P2.2,ACC.2
	MOVE	P2.3,ACC.3
	MOVE	P2.4,ACC.4
	MOVE	P2.5,ACC.5
	MOVE	AT_A14,ACC.6
	MOVE	AT_A15,ACC.7
	;Wait 4 Cyc already in AT_ADDR Sub
	POP	PSW
	POP	ACC	;2 Cyc=4Cyc OK!
	RET		;2 Cyc/
	
;====== AT89CX051P1ڷתֽλ ===========
X051_DATA:
	PUSH	B
	MOV	B,A
	MOV	C,B.7
	MOV	ACC.0,C
	MOV	C,B.6
	MOV	ACC.1,C
	MOV	C,B.5
	MOV	ACC.2,C
	MOV	C,B.4
	MOV	ACC.3,C
	MOV	C,B.3
	MOV	ACC.4,C
	MOV	C,B.2
	MOV	ACC.5,C
	MOV	C,B.1
	MOV	ACC.6,C
	MOV	C,B.0
	MOV	ACC.7,C
	POP	B
	RET	
	


;====== ͨöѭʱӳ==================
;T=[X(X+7) + 4]*(12/Fosc)
DELAY2:	PUSH    DEL_X
DELm1:  DJNZ    DEL_X,DELm1
        POP     DEL_X
        DJNZ    DEL_X,DELAY2
        RET
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
	NOP
	NOP

;====== ͨѭʱӳ==================
DELAY3: PUSH    DEL_X
DEL31:  PUSH    DEL_X
DEL32:  DJNZ    DEL_X,DEL32
        POP     DEL_X
        DJNZ    DEL_X,DEL31
        POP     DEL_X
        DJNZ    DEL_X,DELAY3
        RET
        
        
        

;*********************************************************
;****** жӳ ***********************
;****** ´ٶŻ(          ) ***********************
;*********************************************************
S_INTR:	PUSH 	PSW
	PUSH 	ACC
	MOV 	PSW,#AREA2	;л
	JBC 	RI,RX_STAR
	JBC	TI,TX_STAR

S_QUIT:	POP 	ACC
	POP 	PSW
	RETI
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;====== ͳ ==================================================
;ͼ: R3	:  00,   01,   02,   03,   04,  05, ...,  19,  20.
;б()	: CODE, 04H, PAR1, PAR2,  SUM.
;ͳ()	: CODE, LEN, PAR1, PAR2,  D_0,   D1, ..., D_F, SUM.
;ͻ(ַ)	:  30H, 31H,  32H,  33H,  34H,  35H, ..., 43H, 2FH.
;-----------------------------------------------------------------
TX_STAR:MOV	A,TX_LENG
	ADD	A,#02H
	CJNE	A,TX_CNT,TX_FRAM;
TX_SUM:	MOV	A,TX_SUMB
	MOVE	TB8,P
	MOV	SBUF,A
	JNB	TI,$
	CLR	TI		;
TX_OK:	CLR	IN_TXD		;ڷͱ
	SETB	OK_TXD		;÷ͽ־
	SETB	SM2
	SETB	REN		;Ž
	MOV	R1,#TXD_HAD	;
	MOV	R3,#00H		;
TX_END:	SJMP	TX_QUIT
	;------------------------------------------
TX_FRAM:MOV	A,@R1
	INC 	R1		;ָָһλ
	MOVE	TB8,P
	MOV 	SBUF,A
	ADD	A,TX_SUMB	;-ۼӺ
	MOV	TX_SUMB,A	;/
TX_NEXT:INC 	R3
TX_QUIT:SJMP	S_QUIT
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET

;====== ճ =================================================
;ն̱()	:CODE, 00H,  SUM.
;б()	:CODE, 02H, PAR1, PAR2,  SUM.
;б(Ԥ)	:CODE, 04H, SADH, SADL, EADH, EADL, SUM.
;ճ(д)	:CODE, LEN, SADH, SADL,  D_0,  D_1, ..., D7F, SUM.
;ջ(ַ)	: 7CH, 7DH, 7EH,  7FH,   80H,  81H, ..., FFH, 7BH.
;ռ: R2	:  00,  01,   02,   03,   04,   05, ..., 131, 132.
;----------------------------------------------------------------
RX_STAR:MOV	A,SBUF		;
	MOV	RX_BUFF,A	;
RX_ADR:	JNB	SM2,IS_DATA	;SM2=0 Is OTHER	BYTE	
				;SM2=1 Is ADDRESS BYTE
IS_ADR:	CJNE	A,#MY_ADR,RX_END;No:  Terminate
IS_ME:	CLR	SM2		;
	SETB	IN_RXD		;Set in	Receive	Flag
	MOV	RX_SUMB,A	;Set RX_SUMB=ADDR
	MOV	R2,#00H		;CLEAR RX_CNT
	MOV	R0,#RXD_HAD	;SET RECEIVE POINT
	MOV	RX_LENG,#00H	;
	SJMP	RX_QUIT		;ʽĽմ￪ʼ
	
IS_DATA:MOV	A,RX_LENG
	ADD	A,#02H
RX_SUM:	CJNE	A,RX_CNT,RX_DATA;
IS_SUM:	MOV	A,RX_BUFF
	CJNE	A,RX_SUMB,RX_END
RX_OK:	CLR	REN		;ʱرս
	CLR	IN_RXD		;ڽձ־λ
	SETB	OK_RXD		;ʱȥ
	SJMP	RX_END		;!
				;Ҳжϣ
RX_DATA:MOV	A,RX_BUFF	;ʽձ
	MOV	@R0,A		;R1=1~4
	INC	R0
	ADD	A,RX_SUMB
	MOV	RX_SUMB,A
	SJMP	RX_NEXT

RX_END:	SETB	SM2		;
	SJMP	RX_QUIT		;

RX_NEXT:INC	R2		;׼һֽ

RX_QUIT:LJMP	S_QUIT
;;;;;;; TRAP ;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET



;====== ʼ FSR ӳ ========================
INI_FSR:MOV 	TMOD,#21H   	;
	MOV	PCON,#00H	;SET SMOD=0
	MOV	XICON,#00H	;
	;MOV	IP,#10H		;SET PS=1
	MOV 	TH1,#0FDH	;SMOD=0:19200 bps
	MOV 	TL1,#0FDH	;SMOD=1:38400 bps
COMM_MODE:			;for fosc=22.1184MHz
	MOV 	SCON,#0F0H	;0100 0000B(9 Bit Mode)
	RET
	;;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET


;====== ʾϢ ==========================================================
MSG_HELLO: DB	0DH,0AH,09H,'      ӭʹ',0DH,0AH
	   DB	0DH,0AH,09H,'51PRO 1.0 copyright(C) 2001-2005'
	   DB	0DH,0AH,09H,'WuXi    Gu Jianda. --2002.5.21',0DH,0AH,24H
MSG_STAT:  DB	0DH,0AH,09H,'ͨѶѡƬ͡',0DH,0AH,24H

MSG_BANK:  DB	0DH,0AH,09H,'Ѿȫգ',0DH,0AH,24H	
MSG_UNBAK: DB	0DH,0AH,09H,'Ǹδգ',0DH,0AH,24H	
MSG_ERASE: DB	0DH,0AH,09H,'ȫƬ',0DH,0AH,24H
MSG_LOCK:  DB	0DH,0AH,09H,'оƬܲ',0DH,0AH,24H
MSG_TYPE:  DB	0DH,0AH,09H,'оƬ̵͡ѹý',0DH,0AH,24H

MSG_ISAT:  DB	0DH,0AH,09H,' ATMEL ˾ AT89C',24H	
MSG_NOAT:  DB	0DH,0AH,09H,'˾ AT89C',24H
MSG_UNTYP: DB	0DH,0AH,09H,'Ǹ޷òƷͺϢ...',24H

MSG_VPP:   DB	0DH,0AH,09H,'̵ѹ(V): ',24H

MSG_SIZE:  DB	0DH,0AH,09H,'оƬ: ',0DH,0AH,24H
MSG_UNSIZ: DB	0DH,0AH,09H,'Ǹ',0DH,0AH,24H
MSG_ERR:   DB	0DH,0AH,09H,"Ǹ,ûԪ޷ʶ?",0DH,0AH,'$'

	;;;;;;;;;;;;;;;;;;
	NOP
	NOP
	LJMP	RESET
	NOP
	NOP

;==================================================

	END
